Package com.io7m.waxmill.machines

# Interface WXMBootConfigurationType

All Known Subinterfaces:
  `WXMBootConfigurationType.WXMBootConfigurationGRUBBhyveType`, `WXMBootConfigurationType.WXMBootConfigurationUEFIType`

All Known Implementing Classes:
  `WXMBootConfigurationGRUBBhyve`, `WXMBootConfigurationUEFI`

    public interface WXMBootConfigurationType

A boot configuration.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Interface | Description
  --- | --- | ---
  `static class` | `WXMBootConfigurationType.Kind` | The kind of boot configurations.
  `static interface` | `WXMBootConfigurationType.WXMBootConfigurationGRUBBhyveType` | A boot configuration that uses grub-bhyve.
  `static interface` | `WXMBootConfigurationType.WXMBootConfigurationUEFIType` | A boot configuration that uses UEFI.
  `static interface` | `WXMBootConfigurationType.WXMBootDiskAttachmentType` | A disk attachment.
  `static interface` | `WXMBootConfigurationType.WXMEvaluatedBootCommandsType` | A set of boot commands.
  `static interface` | `WXMBootConfigurationType.WXMEvaluatedBootConfigurationGRUBBhyveType` | A set of evaluated commands used to boot with grub-bhyve.
  `static interface` | `WXMBootConfigurationType.WXMEvaluatedBootConfigurationType` | The type of evaluated boot configurations.
  `static interface` | `WXMBootConfigurationType.WXMEvaluatedBootConfigurationUEFIType` | A set of evaluated commands used to boot with UEFI.
  `static interface` | `WXMBootConfigurationType.WXMGRUBKernelInstructionsType` | Operating system specific GRUB boot instructions.
  `static interface` | `WXMBootConfigurationType.WXMGRUBKernelLinuxType` | Linux kernel instructions.
  `static interface` | `WXMBootConfigurationType.WXMGRUBKernelOpenBSDType` | OpenBSD kernel instructions.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `default java.lang.String` | `comment()` |
  `default java.util.Map<WXMDeviceSlot,​WXMBootDiskAttachment>` | `diskAttachmentMap()` |
  `java.util.List<WXMBootDiskAttachment>` | `diskAttachments()` |
  `WXMBootConfigurationType.Kind` | `kind()` |
  `WXMBootConfigurationName` | `name()` | The unique-within-a-virtual-machine name of the boot configuration.
  `java.util.Set<WXMDeviceSlot>` | `requiredDevices()` |

- ## Method Details

  - ### kind

    WXMBootConfigurationType.Kind kind()
    Returns:
      The kind of boot configuration

  - ### name

    WXMBootConfigurationName name()
    The unique-within-a-virtual-machine name of the boot configuration.
    Returns:
      The name of the boot configuration

  - ### comment

    default java.lang.String comment()
    Returns:
      A comment

  - ### requiredDevices

    java.util.Set<WXMDeviceSlot> requiredDevices()
    Returns:
      The set of devices required by the boot configuration

  - ### diskAttachments

    java.util.List<WXMBootDiskAttachment> diskAttachments()
    Returns:
      The disks attached to the virtual machine on boot

  - ### diskAttachmentMap

    @Derived @Auxiliary default java.util.Map<WXMDeviceSlot,​WXMBootDiskAttachment> diskAttachmentMap()
    Returns:
      The disk attachments by device slot